#include <dirent.h>
#include <grp.h>
#include <pwd.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>
#include "common.h"

#define MAXPATH 256

typedef struct field_info {
    //width
    int w_nlink;
    int w_user;
    int w_group;
    int w_size;
    int w_date;
    //block size
    long nr_blocks;
} field_info_t;

static int max_width(int a, int b) {
    return a > b ? a : b;
}

static void sort_names(char **names, int nr_names) {
    //TODO: sort names in the increasing order
    //   names: array of names
    //   nr_names: number of names

}

/* int print_*(char *buf, ...) function prints to buf and
    returns the number of characters printed excluding '\0'.
*/

static int print_type(char *buf, mode_t mode) {
    //TODO: print the file type (b, c, d, p, l, -, s) to buf
    //         b: block device      c: char device
    //         d: director          p: fifo
    //         l: link              -: regular file
    //         s: socket
    //hint: use sprintf

}

static int print_permission(char *buf, mode_t mode) {
    //TODO: print the r, w, x permissions of the user, group, and other
    //hint: for each character, use sprintf at buf++ location

    return 9;
}

static int print_nlink(char *buf, int w, nlink_t nlink) {
    //TODO: print link count to buf
    //hint: use sprintf with "%*ld" and w for the width

}

static int print_user(char *buf, int w, uid_t uid) {
    //TODO: print user name to buf
    //hint: use getpwuid to get passwd struct
    //hint: use sprintf with "%*s" and -w for the width

}

static int print_group(char *buf, int w, gid_t gid) {
    //TODO: print user name to buf
    //hint: use getgrgid to get group struct
    //hint: use sprintf with "%*s" and -w for the width

}

static int print_size(char *buf, int w, off_t size) {
    //TODO: print the file size to buf
    //hint: use sprintf with "%*ld" and w for the width
    return sprintf(buf, "%*ld", w, size);
}

static int print_date(char *buf, int w, time_t sec) {
    static char *mon[] = { "Jan", "Feb", "Mar", "Apr",
                           "May", "Jun", "Jul", "Aug",
                           "Sep", "Oct", "Nov", "Dec" };
    //print the date of the file

    //TODO: get this_year using time and localtime functions

    //TODO: get tm struct using localtime and sec

    //TODO: print date and return the number of chars printed
    //   if the year of the file is not this_year, print month, day, and year of the file
    //      hint: width of the year is w <= 11? 4: 5
    //   otherwise, print month, day, hour, and min of the file

}

static int print_name(char *buf, mode_t mode, char *fullpath, char *name) {
    //TODO: print the name to buf and return the number of chars printed
    //   if the file type is link, print name -> link
    //      hint: use readlink and null terminate the buffer
    //   otherwise, print the name 

}

static void update_field_info(char *path, char *name, field_info_t *pfi) {
    char buf[MAXPATH];
    char fullpath[MAXPATH];
    sprintf(fullpath, "%s/%s", path, name);

    struct stat sb;
    //TODO: get file information using lstat

    //TODO: update the width fileds of pfi
    //   the width should be the max of the current width and
    //   the number of printed chars to buf
    //   use print_* with w param set to 0 to compute the width
    //   print_*(char *buf, ...) function prints to buf and returns
    //   the number of chars printed excluding '\0'.


    //TODO: if file type is directory or regular file, add half of
    //      the allocated block counts to nr_blocks of pfi

}

static void print_file(char *path, char *name, field_info_t *pfi) {
    char buf[MAXPATH];
    char fullpath[MAXPATH];
    sprintf(fullpath, "%s/%s", path, name);

    struct stat sb;
    //TODO: get file information using lstat
    ON_FALSE_EXIT(lstat(fullpath, &sb) == 0, strmsg("cannot stat %s", fullpath));

    //TODO: print the following fields using print_* functions
    //   print_*(char *buf, ...) function prints to buf and returns
    //   the number of chars printed excluding '\0'.

    //file type
    
    //permissions
   
    //link count
    
    //user

    //group

    //size

    //date

    //file name
}

static void print_dir(char *path) {
    //TODO: open directory

    //count entries to allocate names
    int nr_names = 0;
    struct dirent *dep;
    while((dep = readdir(dp)) != NULL)
        nr_names++;
    char **names = malloc(sizeof(char*) * nr_names);

    //update width and dupe names
    field_info_t fi;
    memset(&fi, 0, sizeof(struct field_info));
    seekdir(dp, 0);

    //TODO: for each entries the directory
    //         - update names array
    //         - update the field info of fi
    //hint: use readdir, strdup, and update_field_info

    //TODO: close directory

    //sort names
    sort_names(names, nr_names);

    //TODO: print total and file information
    //hint: use print_file with path, names array, and fi
    //   print_*(char *buf, ...) function prints to buf and returns
    //   the number of chars printed excluding '\0'.

}


int main(int argc, char **argv) {
    if(argc == 1)
        print_dir(".");
    else if(argc == 2)
        print_dir(argv[1]);
    else
        printf("usage: %s directory\n", argv[0]);
    return 0;
}
